| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | Static Public Member Functions | List of all members
nkWinUi::Slider Class Reference

A graphical slider. More...

Inheritance diagram for nkWinUi::Slider:

## Public Member Functions
| Slider (System *system) noexcept
virtual | ~Slider ()
float | getMin () const
float | getMax () const
float | getCurrent () const
std::function< void(Slider *, float)> | getValueChangeCallback () const
SLIDER_DIRECTION | getDisplayDirection () const
virtual void | setMin (float value)
virtual void | setMax (float value)
virtual void | setCurrent (float value)
virtual void | setValueChangeCallback (std::function< void(Slider *, float)> callback)
virtual void | setDisplayDirection (SLIDER_DIRECTION value)
virtual void | exportIntrospection (nkExport::Node *rootNode) override
virtual void | importClassFromTree (nkExport::Node *rootNode) override
Public Member Functions inherited from nkWinUi::Component
| Component (System *system) noexcept
virtual | ~Component ()
Layout * | getLayout () const
Theme * | getTheme () const
Font * | getFont () const
nkMaths::Point | getPositionInParent () const
nkMaths::Point | getPositionInScreen () const
float | getWidth () const
float | getHeight () const
nkMaths::Rectangle | getAreaInParent () const
nkMaths::Rectangle | getAreaInScreen () const
virtual nkMaths::Point | getBorderExtents () const
virtual float | getBorderExtent (BORDER_KIND border) const
virtual float | getLayoutAllowedWidth () const
virtual float | getLayoutAllowedHeight () const
virtual float | getLayoutAllowedOffsetX () const
virtual float | getLayoutAllowedOffsetY () const
bool | isInitialized () const
System * | getSystem () const
Component * | getParentComponent () const
COMPONENT_TYPE | getComponentType () const
nkMemory::StringView | getComponentName () const
bool | getVisibility () const
virtual nkMemory::StringView | getLabel () const
void * | getData () const
bool | isEnabled () const
bool | isForegroundWindow () const
virtual unsigned int | getZDepth () const
bool | getVisibleOnLoad () const
std::function< bool(Component *)> | getCloseCallback () const
std::function< void(Component *, bool)> | getVisibilityCallback () const
std::function< void(Component *, const ClickEventData &)> | getClickCallback () const
std::function< void(Component *, const WheelEventData &)> | getWheelCallback () const
std::function< void(Component *, const KeyEventData &)> | getKeyCallback () const
virtual Layout * | setLayout (LAYOUT_TYPE layoutType)
virtual void | setTheme (Theme *theme)
virtual void | setFont (Font *font)
virtual void | setPositionInParent (nkMaths::Point position)
virtual void | setPositionInScreen (nkMaths::Point position)
virtual void | setSize (float width, float height)
virtual void | setWidth (float width)
virtual void | setHeight (float height)
void | setMinSize (float width, float height)
void | setMaxSize (float width, float height)
void | setRatio (float widthOverHeight)
virtual void | setAreaInParent (const nkMaths::Rectangle &area)
virtual void | setAreaInScreen (const nkMaths::Rectangle &area)
virtual void | setParentComponent (Component *parent, bool makeItVisible=true)
virtual void | setLabel (nkMemory::StringView label)
void | setComponentName (nkMemory::StringView name)
virtual void | setVisibility (bool value)
void | setData (void *data)
void | setEnabled (bool value)
void | setVisibleOnLoad (bool value)
void | setCloseCallback (std::function< bool(Component *caller)> callback)
void | setVisibilityCallback (std::function< void(Component *caller, bool visibility)> callback)
void | setClickCallback (std::function< void(Component *caller, const ClickEventData &eventData)> callback)
void | setWheelCallback (std::function< void(Component *caller, const WheelEventData &eventData)> callback)
void | setKeyCallback (std::function< void(Component *caller, const KeyEventData &eventData)> callback)
void | addChild (Component *child, bool makeItVisible=true)
void | removeChild (Component *child)
void | removeChild (unsigned int index)
Component * | getChild (unsigned int index)
unsigned int | getChildIndex (Component *child)
void | unloadWithChildren ()
void | loadWithChildren ()
void | updateZDepth ()
void | bringToForeground ()
void | focusWindow ()
nkMaths::Point | getCoordRelativeFromAbsolute (nkMaths::Point absCoords)
nkMaths::Point | getCoordAbsoluteFromRelative (nkMaths::Point relCoords)
virtual void | load ()=0
virtual void | unload ()=0
void | reload ()
virtual void | updateWindow ()
nkImages::Image | paintToImage (bool withFrame=false)
void | simulateEvent (const InputDescriptor &inputDescription)
virtual void | onSized ()
virtual void | exportClassToTree (nkExport::Node *rootNode) override
Public Member Functions inherited from nkExport::Exportable
| Exportable () noexcept
virtual | ~Exportable ()

## Static Public Member Functions
static nkMemory::UniquePtr< Slider > | create (System *system=nullptr)

## Detailed Description

A graphical slider.

Current implementation is a continuous slider, only drawing the cursor over its line. The minimum is set to be on the left, while the right symbolizes the maximum. By registering a callback, it is possible to listen to any input done by a user.

## Constructor & Destructor Documentation

## ◆ Slider()

nkWinUi::Slider::Slider | ( | System * | system | ) |
| noexcept

Constructor.

Parameters

  system | The parent system in which the component will live.

Remarks
  See ComponentManager::createOrRetrieve().

## ◆ ~Slider()

virtual nkWinUi::Slider::~Slider | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getMin()

float nkWinUi::Slider::getMin | ( |  | ) | const

Returns
  Currently set minimum value.

## ◆ getMax()

float nkWinUi::Slider::getMax | ( |  | ) | const

Returns
  Currently set maximum value.

## ◆ getCurrent()

float nkWinUi::Slider::getCurrent | ( |  | ) | const

Returns
  Current slider value.

## ◆ getValueChangeCallback()

std::function<void (Slider*, float)> nkWinUi::Slider::getValueChangeCallback | ( |  | ) | const

Returns
  Currently set callback when value changes.

## ◆ getDisplayDirection()

SLIDER_DIRECTION nkWinUi::Slider::getDisplayDirection | ( |  | ) | const

Returns
  Currently set display direction.

## ◆ setMin()

virtual void nkWinUi::Slider::setMin | ( | float | value | ) |
| virtual

Sets the minimum value for the slider.

Parameters

  value | The value to use as the minimum.

## ◆ setMax()

virtual void nkWinUi::Slider::setMax | ( | float | value | ) |
| virtual

Sets the maximum value for the slider.

Parameters

  value | The value to use as the maximum.

## ◆ setCurrent()

virtual void nkWinUi::Slider::setCurrent | ( | float | value | ) |
| virtual

Sets the current value of the slider.

Parameters

  value | The value to use as the current.

Remarks
  This value can overflow, going past the minimum or maximum value, and be reflected when using the getter. However, it will be clamped visually.

## ◆ setValueChangeCallback()

virtual void nkWinUi::Slider::setValueChangeCallback | ( | std::function< void(Slider *, float)> | callback | ) |
| virtual

Sets the callback function, called whenever the cursor is moved through UI interaction.

Parameters

  callback | The callback to use.

Remarks
  This callback gets called whenever the current value of the slider is changed through interaction. The function will receive the caller, and the new value set. It should return true if the event has been processed, false if it is not the case and the event should be forwarded.

## ◆ setDisplayDirection()

virtual void nkWinUi::Slider::setDisplayDirection | ( | SLIDER_DIRECTION | value | ) |
| virtual

Sets the display direction for the slider.

Parameters

  value | The wanted display direction.

Remarks
  The default value is AUTOMATIC, meaning the slider will adapt to the component's size.

## ◆ exportIntrospection()

virtual void nkWinUi::Slider::exportIntrospection | ( | nkExport::Node * | rootNode | ) |
| override virtual

A basic exporting capability, for components inheriting. Components inheriting this class should rather reimplement this function to export their internal data.

Parameters

  rootNode | The root of the tree to export into.

Reimplemented from nkWinUi::Component.

## ◆ importClassFromTree()

virtual void nkWinUi::Slider::importClassFromTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

A basic importing capability.

Parameters

  rootNode | The root of the tree to import from.

Reimplemented from nkWinUi::Component.

## ◆ create()

static nkMemory::UniquePtr<Slider> nkWinUi::Slider::create | ( | System * | system = `nullptr` | ) |
| static

Creates a standalone component, linking it to a system, but no manager. This method can be used to allocate a component and manually manage its lifetime.

Parameters

  system | The system to create the component into. If left to nullptr, then the Singleton instance will be used.

Returns
  The created component instance.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsWinUi/Components/Slider.h